# Notices for CyberDog

## Copyright
---
CyberDog (ROS 2) is released under Apache 2.0 license.

> Copyright (c) 2021 Beijing Xiaomi Mobile Software Co., Ltd. All rights reserved.
> 
> Licensed under the Apache License, Version 2.0 (the "License");
> you may not use this file except in compliance with the License.
> You may obtain a copy of the License at
> 
>     http://www.apache.org/licenses/LICENSE-2.0
> 
> Unless required by applicable law or agreed to in writing, software
> distributed under the License is distributed on an "AS IS" BASIS,
> WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
> See the License for the specific language governing permissions and
> limitations under the License.

## Source Code & Projects
---
The project maintains the following source code repositories:

- [CybereDog Main. (cyberdog_ros2)](https://github.com/MiRoboticsLab/cyberdog_ros2)
- [Localization, Navigation, Tracking. (athena_automation)](https://partner-gitlab.mioffice.cn/cyberdog/athena_automation)
- [Android APP (Closed Source)](http://cdn.cnbj1.fds.api.mi-img.com/ota-packages/apk/cyberdog_app.apk)

## Third-party Dependencies
---
alsa-lib (v1.1.3)
- License: LGPL-2.1
- Project: https://github.com/alsa-project/alsa-lib
- Source: https://github.com/alsa-project/alsa-lib/releases/tag/v1.1.3
- Usage: as-is, dynamic-linking

bluepy (v1.3.0)
- License: public-domain
- Project: https://github.com/IanHarvey/bluepy
- Source: https://github.com/IanHarvey/bluepy/releases/tag/v%2F1.3.0
- Usage: as-is, dynamic-linking

cascade_lifecycle (1.0.0)
- License: Apache-2.0
- Project: https://github.com/fmrico/cascade_lifecycle
- Source: https://github.com/fmrico/cascade_lifecycle/releases/tag/1.0.0
- Usage: modified, dynamic-linking

Cheetah-Software (master)
- License: MIT
- Project: https://github.com/mit-biomimetics/Cheetah-Software
- Source: https://github.com/mit-biomimetics/Cheetah-Software/tree/master
- Usage: modified, standalone

commons-codec(1.15)
- License: Apache-2.0
- Project: https://github.com/apache/commons-codec
- Source: https://github.com/apache/commons-codec/releases/tag/rel%2Fcommons-codec-1.15
- Usage: as-is, static-linking

commons-compress (1.21)
- License: Apache-2.0
- Project: https://github.com/apache/commons-compress
- Source: https://github.com/apache/commons-compress/releases/tag/rel%2F1.21
- Usage: as-is, static-linking

commons-lang(3.11)
- License: Apache-2.0
- Project: https://github.com/apache/commons-lang
- Source: https://github.com/apache/commons-lang/releases/tag/rel%2Fcommons-lang-3.11
- Usage: as-is, static-linking

costmap_converter (ros2)
- License: BSD-3-Clause
- Project: https://github.com/rst-tu-dortmund/costmap_converter
- Source: https://github.com/rst-tu-dortmund/costmap_converter/tree/ros2
- Usage: modified, dynamic-linking

curl (7.75.0)
- License: MIT
- Project: https://github.com/curl/curl
- Source: https://github.com/curl/curl/releases/tag/curl-7_75_0
- Usage: as-is, static-linking

easypermissions (3.0.0)
- License: Apache-2.0
- Project: https://github.com/googlesamples/easypermissions
- Source: https://github.com/googlesamples/easypermissions/releases/tag/3.0.0
- Usage: as-is, static-linking

Eigen (3.4.0)
- License: MPL-2
- Project: https://gitlab.com/libeigen/eigen
- Source: https://gitlab.com/libeigen/eigen/-/tags/3.4.0
- Usage: as-is, dynamic-linking

ffmpeg (4.3.2)
- License: LGPL-2.1
- Project: https://git.ffmpeg.org/ffmpeg.git
- Source: http://ffmpeg.org/releases/ffmpeg-4.3.2.tar.xz
- Usage: as-is, dynamic-linking

glide (v4.12.0)
- License: BSD-2-Clause, part MIT and Apache-2.0
- Project: https://github.com/bumptech/glide
- Source: https://github.com/bumptech/glide/releases/tag/v4.12.0
- Usage: as-is, static-linking

grpc (v1.36.3)
- License: Apache-2.0
- Project: https://github.com/grpc
- Source: https://github.com/grpc/grpc/releases/tag/v1.36.3
- Usage: as-is, dynamic-linking

grpc-java (v1.38.0)
- License: Apache-2.0
- Project: https://github.com/grpc/grpc-java
- Source: https://github.com/grpc/grpc-java/releases/tag/v1.38.0
- Usage: as-is, static-linking

g2o (20201223_git)
- License: BSD-2-Clause
- Project: https://github.com/RainerKuemmerle/g2o
- Source: https://github.com/RainerKuemmerle/g2o/releases/tag/20201223_git
- Usage: as-is, dynamic-linking

gson (parent-2.86)
- License: Apache-2.0
- Project: https://github.com/google/gson
- Source: https://github.com/google/gson/releases/tag/gson-parent-2.8.6
- Usage: as-is, static-linking

ijkplayer (k0.8.8)
- License: LGPL-2.1
- Project: https://github.com/bilibili/ijkplayer
- Source: https://github.com/bilibili/ijkplayer/releases/tag/k0.8.8
- Usage: as-is, static-linking

jsoncpp (1.8.1)
- License: MIT
- Project: https://github.com/open-source-parsers/jsoncpp
- Source: https://github.com/open-source-parsers/jsoncpp/releases/tag/1.8.1
- Usage: as-is, static-linking

librealsense (2.48.0)
- License: Apache-2.0
- Project: https://github.com/IntelRealSense/librealsense
- Source: https://github.com/IntelRealSense/librealsense/releases/tag/v2.48.0
- Usage: as-is, dynamic-linking

Lightweight Communications and Marshalling(LCM) (v1.4.0) 
- License: LGPL-2.1
- Project: https://github.com/lcm-proj/lcm
- Source: https://github.com/lcm-proj/lcm/releases/tag/v1.4.0
- Usage: as-is, static-linking

mpg123 (1.25.10)
- License: LGPL-2.0
- Project: http://mpg123.org/cgi-bin/scm/mpg123
- Source: https://sourceforge.net/projects/mpg123/files/mpg123/1.25.10/
- Usage: as-is, dynamic-linking

navigation2 (1.0.0)
- License: LGPL-2.1/BSD-3-Clause/Apache-2.0
- Project: https://github.com/ros-planning/navigation2
- Source: https://github.com/ros-planning/navigation2/releases/tag/1.0.0
- Usage: modified, dynamic-linking

nginx (1.18.0)
- License: BSD-2-Clause
- Project: https://nginx.org/
- Source: http://nginx.org/download/nginx-1.18.0.tar.gz
- Usage: as-is, standalone

okhttp (parent-4.9.0)
- License: Apache-2.0
- Project: https://github.com/square/okhttp
- Source: https://github.com/square/okhttp/releases/tag/parent-4.9.0
- Usage: as-is, static-linking

OpenCV (4.2.0)
- License: Apache-2.0
- Project: https://github.com/opencv/opencv
- Source: https://github.com/opencv/opencv/releases/tag/4.2.0
- Usage: as-is, dynamic-linking

open_vins (2.3)
- License: GPL-3
- Project: https://github.com/rpng/open_vins
- Source: https://github.com/rpng/open_vins/releases/tag/v2.3
- Usage: modified, standalone

opensssl (1.1.1k)
- License: Apache-2.0
- Project: https://github.com/openssl/openssl
- Source: https://github.com/openssl/openssl/releases/tag/OpenSSL_1_1_1k
- Usage: as-is, static-linking

retrofit2 (parent-2.2.0)
- License: Apache-2.0
- Project: https://github.com/square/retrofit
- Source: https://github.com/square/retrofit/releases/tag/parent-2.2.0
- Usage: as-is, static-linking

ROS 2 (Foxy Fitzroy)
- License: Apache-2.0
- Project: https://github.com/ros2/ros2
- Source: https://github.com/ros2/ros2/releases/tag/release-foxy-20201211
- Usage: as-is, dynamic-linking

ros2_socketcan (1.0.0)
- License: Apache-2.0
- Project: https://github.com/autowarefoundation/ros2_socketcan
- Source: https://github.com/autowarefoundation/ros2_socketcan/releases/tag/1.0.0
- Usage: modified, dynamic-linking

realsense-ros (3.2.2)
- License: Apache-2.0
- Project: https://github.com/IntelRealSense/realsense-ros
- Source: https://github.com/IntelRealSense/realsense-ros/releases/tag/3.2.2
- Usage: modified, standalone

rtabmap (0.20.7)
- License: BSD-3-Clause
- Project: https://github.com/introlab/rtabmap
- Source: https://github.com/introlab/rtabmap/releases/tag/0.20.7
- Usage: modified, dynamic-linking

rtabmap_ros (0.20.7)
- License: BSD-3-Clause
- Project: https://github.com/introlab/rtabmap_ros
- Source: https://github.com/introlab/rtabmap_ros/releases/tag/0.20.7
- Usage: modified, dynamic-linking

rxjava2 (2.2.21)
- License: Apache-2.0
- Project: https://github.com/square/retrofit
- Source: https://github.com/ReactiveX/RxJava/releases/tag/v2.2.21
- Usage: as-is, static-linking

servo_joint_motor (master)
- License: MIT
- Project: https://github.com/bgkatz/motorcontrol
- Source: https://github.com/bgkatz/motorcontrol/tree/master
- Usage: modified, standalone

Simple DirectMedia Layer library 2(SDL2) (2.0.14)
- License: zlib
- Project: https://github.com/libsdl-org/SDL
- Source: https://github.com/libsdl-org/SDL/releases/tag/release-2.0.14
- Usage: as-is, dynamic-linking

SDL2_mixer (2.0.4)
- License: zlib
- Project: https://github.com/libsdl-org/SDL_mixer
- Source: https://github.com/libsdl-org/SDL_mixer/releases/tag/release-2.0.4
- Usage: as-is, dynamic-linking

teb_local_planner (ros2)
- License: BSD-3-Clause
- Project: https://github.com/rst-tu-dortmund/teb_local_planner
- Source: https://github.com/rst-tu-dortmund/teb_local_planner/tree/ros2-master
- Usage: modified, dynamic-linking

toml11 (v3.7)
- License: MIT
- Project: https://github.com/ToruNiina/toml11
- Source: https://github.com/ToruNiina/toml11/releases/tag/v3.7.0
- Usage: as-is, static-linking

yaml-cpp (0.6.3)
- License: MIT
- Project: https://github.com/jbeder/yaml-cpp
- Source: https://github.com/jbeder/yaml-cpp/releases/tag/yaml-cpp-0.6.3
- Usage: as-is, dynamic-linking
